#define ASM 1
#include "mboot.h"

#ifdef __ELF__
#	define MULTIBOOT_HEADER_FLAGS         (0x00000003)
#else
# 	define MULTIBOOT_HEADER_FLAGS         (0x00010003)
#endif

.global start,_start
.text
start:				// entry point
_start:
     jmp     multiboot_entry	// scavalchiamo la struttra richiesta
     				// dal bootstrap loader, che deve
				// trovarsi verso l'inizio del file

     .align  4
     // le seguenti informazioni sono richieste dal bootstrap loader
multiboot_header:
     .long   MULTIBOOT_HEADER_MAGIC 				// valore magico
     .long   MULTIBOOT_HEADER_FLAGS   				// flag
     .long   -(MULTIBOOT_HEADER_MAGIC + MULTIBOOT_HEADER_FLAGS) // checksum
     .long   multiboot_header
     .long   _start
     .long   _edata
     .long   _end
     .long   multiboot_entry

multiboot_entry:
	call init_all
#	call ___main
        call main
	call stop_all
	lidt triple_fault_idt
	int $1

triple_fault_idt:
	.word 0
	.long 0
        

.bss
stack:
#        .space 65536, 0
	.space 1024, 0
estack: